#include <stdio.h>
#include <math.h>
// produce nfits.pos9
// (name) usl 16-20.5 rms match sky+see 16-21(old) rms match sk+se exp obj
//  19     5     7.3  6.3   5   8.2+5.2  6.3      6.3   5     13   4   9,=98
#define DIR "/line6/cat"
#define ndate 67
int obsdate[ndate]={ 101002,101003,101004,                              //2010
                     101103,101104,101105,101106,101107,101108,
                     101204,101205,101206,101207,101208,101209,
                     110918,110919,110920,110921,110922,110923,110924,  //2011
                     111024,111025,111026,111027,111028,111029,111030,111031,
                     111123,111124,111126,111127,111128,111129,111130,111201,
                     111224,111226,111227,111228,111229,111230,111231,120101,
                     120918,120919,120920,120921,                       //2012
                     121009,121010,121011,121012,121013,121014,121015,121016,
                                          121017,121018,121019,121020,121021,
                     121112,121113,121114,121115};
char head[72][80];
FILE *fp,*fp1,*fp2;

main(int ac,char **av)
{
  char a[99],f1[50],t[80];
  int ip,i,j,k,ie;
  int usl,u1,u3;
  float c1,c3,r1,r3;
  float sky1,sky3,see1,see3;
  char obj[8];
  if(ac<2){ printf("\n\t*** produce nfits.cali ******\n\n"); exit(0); }
  fp2=fopen("nfits.cali","w");
  fprintf(fp2,"#   date/name       usl 16-20.5 rms match sky see");
  fprintf(fp2,"     16-21(old) rms match sky see   exp object\n#"); 
  for(i=0;i<95;i++)fprintf(fp2,"-"); fprintf(fp2,"\n");
  for(ip=0;ip<ndate;ip++){
    printf("%d\n",obsdate[ip]);
    sprintf(a,"ls %s/%d/p*.fit >1.1",DIR,obsdate[ip]);
    system(a);
    fp1=fopen("1.1","r");
l10:
    fgets(a,99,fp1); if(feof(fp1))goto l20;
    strcpy(f1,a); k=strlen(f1); f1[k-1]=0;
    fp=fopen(f1,"rb"); 
    fread(head,72,80,fp); fclose(fp);
    c1=r1=0; u1=usl=0;
    k=indexpos(head,"CALIBRAT",72);
    if(k!=72){
      sscanf(&head[k][20],"%f",&c1);
      sscanf(&head[k][37],"%f",&r1);
      if(head[k][36]!=32){
        sscanf(&head[k][48],"%d",&usl);
        sscanf(&head[k][62],"%d",&u1);
      } else {
        for(i=42;i<66;i++)if(head[k][i]<48 || head[k][i]>57)head[k][i]=32;
        sscanf(&head[k][42],"%d%d%d",&usl,&u1,&k); // nccd,star,iturn
        if(usl>9)usl=9; usl=usl*100+k; usl=-usl;  
      }
    }
    k=indexpos(head,"SKYADU  ",72);
    sscanf(&head[k][20],"%f",&sky1);
    sscanf(&head[k+1][20],"%f",&see1);
    k=indexpos(head,"EXPTIME ",72);
    sscanf(&head[k][20],"%f",&c3); ie=c3+0.5;
    k=indexpos(head,"OBJECT  ",72);
    for(i=0;i<7;i++)obj[i]=head[k][i+11]; obj[i]=0;
    
    u3=0; c3=r3=sky3=see3=0.;
    if(obsdate[ip]<=120101){
      i=strlen(DIR)+1; f1[i+23]=0;
      sprintf(a,"/line3/uband-data/cat/%s",&f1[i]);
      fp=fopen(a,"rb");
      if(fp){
        fread(head,72,80,fp); fclose(fp);
        k=indexpos(head,"CALIBRAT",72);
        if(k!=72 && head[k][28]!=32){
          sscanf(&head[k][20],"%f",&c3);
          sscanf(&head[k][37],"%f",&r3);
          sscanf(&head[k][62],"%d",&u3);
        }
        k=indexpos(head,"SKYADU  ",72);
        sscanf(&head[k][20],"%f",&sky3);
        sscanf(&head[k+1][20],"%f",&see3);
      }
    }
    i=strlen(DIR)+1; f1[i+19]=0;
    fprintf(fp2,"%s%5d%7.3f%6.3f%5d%8.2f%5.2f%6.3f%6.3f%5d%8.2f%5.2f%4d %s\n",
          &f1[i],usl,c1,r1,u1,sky1,see1,c3,r3,u3,sky3,see3,ie,obj);
    goto l10;
l20:
    fclose(fp1); 
  }
  fclose(fp2);
// --- produce npv_12.dat
  fp=fopen("nfits.cali","r");
  fp2=fopen("npv_12.dat","w");
  i=0; k=-1;
l110:
  fgets(a,99,fp); if(feof(fp))goto l120;
  if(a[0]=='#')goto l110;
  a[6]=32; i++;
  sscanf(a,"%d",&j);
  if(j!=k)fprintf(fp2,"%d %d\n",j,i);
  k=j;
  goto l110;
l120:
  j=0; fprintf(fp2,"%d %d\n",j,i);  
  fclose(fp); fclose(fp2);
  printf("\n\t nfits.cali  npv_12.dat  produced !\n");
}

